indexing
   description: "PART that contains other parts"

class COMPOSITE_PART
  inherit
    COMPOSITE [PART] -- Handles parent and children management features
    PART
      redefine make end

--------------------------
feature {NONE} -- Initialization

make (the_name : STRING ; cost_to_retailer : REAL) is
  -- Set the name and cost of the PART.
  -- Create and initialize childrens.
  do
    Precursor(the_name, cost_to_retailer)
    create children.make
  end
		
--------------------------
feature -- Pricing

price : REAL is
  -- Price of this composite part plus sum the net prices of the children
  do
    from  children.start ; Result := cost * profit_margin
    until children.after
    loop
      Result := Result + children.item.price
      children.forth	
    end
  end
		
discount_price : REAL is
  -- Discount price for special customers.
  do
    Result := price * 0.9
  end

invariant
  parent_child_link: parent /= Void implies parent.has(Current)
	
end
