indexing
   description: "Piece of electronic or computer equipment"
 
deferred class PART

--------------------------
feature {NONE} -- Initialization

make (s : STRING; cost_to_retailer : REAL) is
  require  s_not_void: s /= Void and cost_to_retailer > 0
  do
    name := s  ;  cost := cost_to_retailer
  end

--------------------------
feature -- Attributes

name : STRING  -- Name of this equipment
cost : REAL    -- Cost to retailer of this piece of equipment
profit_margin : REAL is 1.25
    -- Amount to multiply cost to get net_price for this part

--------------------------
feature -- Pricing

price : REAL is deferred end
  -- Price to customer for this part

discount_price : REAL is deferred end 
  -- Price with discounts for this part

invariant
   name_not_void: name /= Void
   positive_price: price > 0.0
   positive_cost: cost > 0.0
   real_discount: price >= discount_price

end
